require 'amrita2/core'

module Amrita2
  class Template
    include Amrita2
    include Core

    def initialize(rexml_doc)
      root = rexml_doc.root
      spec = Amrita2::make_default_spec(root)
      m = spec.create_template_module(rexml_doc)
      extend m
    end

    def expand(out, data=nil, &block)
      if data
        Amrita2::default_expand(self, out, data)
      else
        expand_template(out, &block)
      end
    end
  end

  class TemplateFile < Template
    def initialize(fname)
      super(REXML::Document.new(File.new(fname)))
    end
  end

  class TemplateText < Template
    def initialize(text)
      super(REXML::Document.new(text))
    end
  end
end
