

TEMPLATE_TEXT = <<END
<html>
<body>
  <h1 id="title"></h1>
  <p id="body"></p>
</body>
</html>
END

class Hello
  include Amrita2::TemplateFactory

  dyn_elem(:title)
  dyn_elem(:body)
end

T = Hello.new(TEMPLATE_TEXT)

t = T.new

t.title("hello amrita2")
t.body <<END
Generated by amrita2
END


class ListF
  include Amrita2::TemplateFactory

  dyn_elem(:item)
  dyn_elem(:body)
end

List = ListF.new <<END
<html>
<body>
  <ul>
    <li id="item"></li>
  </ul>
</body>
</html>
END

t = List.new

(1..3).each do |i|
  t.item(i)
end

t.out(STDOUT)

class TableF
  include Amrita2::TemplateFactory

  dyn_elem(:line) do 
    dyn_elem(:title, :match=>MatchByTag(:td))
    dyn_elem(:site, :match=>MatchByTag(:td)) do
      dyn_elem(:link, :match =>MatchByTag(:a),
               :dyn_attr => %w(href)
               )
    end
  end
end

Table = TableF.new <<END
<html>
<body>
  <table>
    <tr id="line"><td></td><td><a href="url">text</a></td></tr>
  </table>
</body>
</html>
END


data = [
  [ "ruby", "ruby home page", "http://www.ruby-lang.org/" ]
]

t = Table.new

data.each do |lang, site, url|
  t.line do |e|
    e.title(lang)
    e.site do |l|
       l.link(site, :href=url)
    end
  end
end

STDOUT << t


